------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2008-2010 Vadim Godunko <vgodunko@gmail.com>                 --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--  $Revision: 3769 $ $Date: 2010-10-24 03:16:28 +0400 (Sun, 24 Oct 2010) $
------------------------------------------------------------------------------
with Ada.Unchecked_Conversion;

package body Qt_Ada.Internals.Generic_Q_Flags is

   use type Interfaces.C.unsigned;

   function To_unsigned is
     new Ada.Unchecked_Conversion (Enum, Interfaces.C.unsigned);

   ----------
   -- "or" --
   ----------

   function "or" (Left : Enum; Right : Enum) return Flags is
   begin
      return Flags (To_unsigned (Left) or To_unsigned (Right));
   end "or";

   ----------
   -- "or" --
   ----------

   function "or" (Left : Enum; Right : Flags) return Flags is
   begin
      return Flags (To_unsigned (Left) or Interfaces.C.unsigned (Right));
   end "or";

   ----------
   -- "or" --
   ----------

   function "or" (Left : Flags; Right : Enum) return Flags is
   begin
      return Flags (Interfaces.C.unsigned (Left) or To_unsigned (Right));
   end "or";

   ----------
   -- "or" --
   ----------

   overriding function "or" (Left : Flags; Right : Flags) return Flags is
   begin
      return
        Flags (Interfaces.C.unsigned (Left) or Interfaces.C.unsigned (Right));
   end "or";

end Qt_Ada.Internals.Generic_Q_Flags;
